# Rage Framework (RageFW)
RageFW is a type-safe framework for developing Rage:MP servers. Designed with developers in mind, RageFW brings structure and efficiency to your Rage:MP servers, ensuring robust and maintainable code

## Features
 - **Type-Safe Development:** Eliminate runtime errors and enhance code reliability with RageFW comprehensive type safety, making your RP server's development smoother than a Sunday drive through Los Santos

 - **Wrapped RPC client:** Communicate effortlessly between server, client and cef with RPC system, wrapped in a cozy custom-typed blanket for your peace of mind

 - **Logging System:** Keep track of server activities and debug like a pro with our built-in, feature-rich logging system. After all, even virtual cops need evidence

## Getting Started
You can find out more about our CLI [here](https://git.entityseven.com/entityseven/rage-framework/wiki/CLI)

At the moment automation we have only works via [pnpm](https://pnpm.io/). To scaffold a basic project with minor settings you can use our CLI:

``pnpm create rage-fw``

This will give you a few options, among them, you can find ``Initialize new project``. Use that option to scaffold a new project for yourself using the preferred frontend framework

## Documentation
[Available here](https://git.entityseven.com/entityseven/rage-framework/wiki/Docs+%40+0.0.30-alpha.0.-)

## Contributing
Join our community of developers and contribute to the ongoing development of RageFW. At the moment the only way to contribute is opening issues 

## Support
Need help? Reach out via our community forums or contact us directly through our support channels. We're committed to help you as we can

## License
Licensed under **Custom Attribution-NoDerivs Software License**

> *RageFW - because in the world of GTA:RP, nobody has time for type errors*